;;;=================================================================
;;;
;;; FOG.LSP 1.01
;;;
;;; Passer d'une prsentation  une autre
;;;
;;; Copyright (C) Patrick_35
;;;
;;;=================================================================

(defun c:fog(/ doc dcl lay lst n pos ptxy res s tab *errfog*)

  (defun *errfog* (msg)
    (or (member (strcase msg) '("FUNCTION CANCELLED" ""QUIT / EXIT ABORT"" "FONCTION ANNULEE" "QUITTER / SORTIR ABANDON"))
      (princ (strcat "\nErreur : " msg))
    )
    (vla-endundomark doc)
    (setq *error* s)
    (princ)
  )

  (if (setq dcl (findfile "fog.dcl"))
    (if (setq doc (vla-get-activedocument (vlax-get-acad-object))
	      dcl (load_dialog dcl)
	      pos "0"
	      n 1
	      s *error*
	      *error* *errfog*
	)
      (progn
	(vla-startundomark doc)
	(vlax-for lay (vla-get-layouts doc)
	  (setq lst (cons (cons (vla-get-taborder lay) lay) lst))
	)
	(while (setq lay (cdr (assoc n lst)))
	  (if (equal (vla-get-activelayout doc) lay)
	    (setq pos (itoa (1- n)))
	  )
	  (setq tab (cons lay tab)
		n (1+ n)
	  )
	)
	(setq lst (reverse tab))
	(if (setq ptxy (getenv "Patrick_35_Fog_x"))
	  (setq ptxy (list (atoi ptxy) (atoi (getenv "Patrick_35_Fog_y"))))
	  (setq ptxy '(-1 -1))
	)
	(while (/= res 0)
	  (new_dialog "fog" dcl "" ptxy)
	  (start_list "folio")
	    (mapcar '(lambda(x) (add_list (vla-get-name x))) lst)
	  (end_list)
	  (set_tile "titre" "FOG V1.01")
	  (set_tile "folio" pos)
	  (mode_tile "folio" 2)
	  (action_tile "folio"  "(setq pos $value)(setq ptxy (done_dialog 1))")
	  (action_tile "cancel" "(setq ptxy (done_dialog 0))")
	  (setq res (start_dialog))
	  (if (= res 1)
	    (vla-put-activelayout doc (nth (atoi pos) lst))
	  )
	  (setenv "Patrick_35_Fog_x" (itoa (car  ptxy)))
	  (setenv "Patrick_35_Fog_y" (itoa (cadr ptxy)))
	)
	(vla-endundomark doc)
	(setq *error* s)
	(unload_dialog dcl)
      )
    )
    (alert "Le fichier FOG.DCL est introuvable.")
  )
  (princ)
)

(setq nom_lisp "FOG")
(if app
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " charg."))
    (princ (strcat "\n" nom_lisp ".LSP Charg......Tapez " nom_lisp " pour l'xecuter.")))
  (princ (strcat "\n" nom_lisp ".LSP Charg......Tapez " nom_lisp " pour l'xecuter.")))
(setq nom_lisp nil)
(princ)